<?php
namespace Services;

use Zeedhi\Framework\DTO;

class Gop01200ArrecadacaoAdministrativaService {
    protected $connection;
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    public function beginTransaction() {
        $this->connection->beginTransaction();
    }
    
    public function commit() {
        $this->connection->commit();
    }
    
    public function rollback() {
        $this->connection->rollback();
    }
    
    public function saveUnit($params) {
        $query = "DECLARE V_NRARRECADAADMGER NUMBER;
                    BEGIN 
                       UPDATE ARRECADAADMGER 
                          SET IDATIVO = 'S' 
                        WHERE CDFILIALADM = :P_CDFILIAL
                          AND NRORG = :P_NRORG;
                    
                       IF (SQL%ROWCOUNT = 0) THEN
                           NOVO_CODIGO('ARRECADAADMGER', V_NRARRECADAADMGER);
                           INSERT INTO ARRECADAADMGER (NRARRECADAADMGER, CDANO, CDFILIALADM, NRORG) 
                           VALUES (V_NRARRECADAADMGER, TO_CHAR(SYSDATE, 'YYYY'), :P_CDFILIAL, :P_NRORG);
                       END IF;
                  END;";
        try {
            $stmt = $this->connection->prepare($query);
            $stmt->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
     public function saveUnityGeneral($params) {
        $query = "DECLARE V_NRARRECADAADMGER NUMBER;
                    BEGIN
                        UPDATE ARRECADAADMGER
                        SET
                            VRMES01 = :P_VRMES01,
                            VRMES02 = :P_VRMES02,
                            VRMES03 = :P_VRMES03,
                            VRMES04 = :P_VRMES04,
                            VRMES05 = :P_VRMES05,
                            VRMES06 = :P_VRMES06,
                            VRMES07 = :P_VRMES07,
                            VRMES08 = :P_VRMES08,
                            VRMES09 = :P_VRMES09,
                            VRMES10 = :P_VRMES10,
                            VRMES11 = :P_VRMES11,
                            VRMES12 = :P_VRMES12
                        WHERE
                            CDFILIALADM = :P_CDFILIALADM
                            AND CDANO = :P_CDANO;
                        IF ( SQL%ROWCOUNT = 0 ) THEN
                            NOVO_CODIGO('ARRECADAADMGER', V_NRARRECADAADMGER);
                            INSERT INTO ARRECADAADMGER (
                                NRARRECADAADMGER,
                                CDANO,
                                CDFILIALADM,
                                VRMES01,
                                VRMES02,
                                VRMES03,
                                VRMES04,
                                VRMES05,
                                VRMES06,
                                VRMES07,
                                VRMES08,
                                VRMES09,
                                VRMES10,
                                VRMES11,
                                VRMES12,
                                NRORG
                            ) VALUES (
                                V_NRARRECADAADMGER,
                                :P_CDANO,
                                :P_CDFILIALADM, 
                                :P_VRMES01,
                                :P_VRMES02,
                                :P_VRMES03,
                                :P_VRMES04,
                                :P_VRMES05,
                                :P_VRMES06,
                                :P_VRMES07,
                                :P_VRMES08,
                                :P_VRMES09,
                                :P_VRMES10,
                                :P_VRMES11,
                                :P_VRMES12,
                                :P_NRORG);
                        END IF;
                    END;";
        try {
            $stmt = $this->connection->prepare($query);
            $stmt->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function saveUnityGrid($params) {
        $query = "DECLARE   V_NRARRECADAADMUNI NUMBER;
                    BEGIN
                            UPDATE ARRECADAADMUNI
                               SET
                                    VRMES01 = :P_VRMES01,
                                    VRMES02 = :P_VRMES02,
                                    VRMES03 = :P_VRMES03,
                                    VRMES04 = :P_VRMES04,
                                    VRMES05 = :P_VRMES05,
                                    VRMES06 = :P_VRMES06,
                                    VRMES07 = :P_VRMES07,
                                    VRMES08 = :P_VRMES08,
                                    VRMES09 = :P_VRMES09,
                                    VRMES10 = :P_VRMES10,
                                    VRMES11 = :P_VRMES11,
                                    VRMES12 = :P_VRMES12
                            WHERE   
                                    CDFILIAL = :P_CDFILIAL
                                    AND CDFILIALADM = :P_CDFILIALADM
                                    AND CDANO = :P_CDANO;
                        
                        IF ( SQL%ROWCOUNT = 0 ) THEN
                            NOVO_CODIGO('ARRECADAADMUNI', V_NRARRECADAADMUNI);
                            INSERT INTO ARRECADAADMUNI (
                                NRARRECADAADMUNI,
                                CDANO,
                                CDFILIALADM,
                                CDFILIAL,
                                VRMES01,
                                VRMES02,
                                VRMES03,
                                VRMES04,
                                VRMES05,
                                VRMES06,
                                VRMES07,
                                VRMES08,
                                VRMES09,
                                VRMES10,
                                VRMES11,
                                VRMES12,
                                NRORG
                            ) VALUES (
                                 V_NRARRECADAADMUNI,
                                :P_CDANO,
                                :P_CDFILIALADM, 
                                :P_CDFILIAL,
                                :P_VRMES01,
                                :P_VRMES02,
                                :P_VRMES03,
                                :P_VRMES04,
                                :P_VRMES05,
                                :P_VRMES06,
                                :P_VRMES07,
                                :P_VRMES08,
                                :P_VRMES09,
                                :P_VRMES10,
                                :P_VRMES11,
                                :P_VRMES12,
                                :P_NRORG);
                        END IF;
                    END;";
        try {
            $stmt = $this->connection->prepare($query);
            $stmt->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function cadAutomatic($params, $mes, $paramMeses, $mesUpdate) {
         $query = "DECLARE V_NRARRECADAADMUNI NUMBER;
                      BEGIN          
                        FOR C_LISTA IN (
                            SELECT
                                    :P_CDANO CDANO,
                                    LA.CDLISTA LACDLISTA, 
                                    LU.CDLISTA LUCDLISTA,
                                    :P_NRORG NRORG
                              FROM LISTA LU, LISTA LA
                             WHERE LU.NRLISTA = :P_NRLISTA
                               AND LA.NRLISTA = :P_CDFILIALADM
                            )
                     LOOP 
                            UPDATE ARRECADAADMUNI
                               SET ". $mesUpdate ."
                             WHERE   
                                    CDFILIAL = C_LISTA.LUCDLISTA
                                    AND CDFILIALADM = C_LISTA.LACDLISTA
                                    AND CDANO = C_LISTA.CDANO;
                        
                            IF ( SQL%ROWCOUNT = 0 ) THEN
                                NOVO_CODIGO('ARRECADAADMUNI', V_NRARRECADAADMUNI);
                                INSERT INTO ARRECADAADMUNI (
                                    NRARRECADAADMUNI,
                                    CDANO,
                                    CDFILIALADM,
                                    CDFILIAL,
                                   ". $mes ."
                                    NRORG
                                ) 
                                VALUES (
                                    V_NRARRECADAADMUNI,
                                    C_LISTA.CDANO,
                                    C_LISTA.LACDLISTA,
                                    C_LISTA.LUCDLISTA,
                                    ". $paramMeses ."
                                    C_LISTA.NRORG
                                );
                             END IF;
                          END LOOP;
                    END;";
        try {
            $stmt = $this->connection->prepare($query);
            $stmt->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function checkRowsMonthCadAutomaic($paramSelect, $mes){
        $query = "SELECT SUM (VRMES)VRMES, INITCAP(TRIM(TO_CHAR(TO_DATE(SUBSTR(UNI.MES, 6, 2), 'MM'), 'MONTH', 'NLS_DATE_LANGUAGE = PORTUGUESE')))MES, UNI.CDFILIAL, F.NMFILIAL
                      FROM(
                            SELECT * 
                              FROM(
                                SELECT U.* 
                                  FROM ARRECADAADMUNI U, LISTA L
                                 WHERE U.CDFILIAL = L.CDLISTA
                                   AND U.CDANO = :P_CDANO
                                   AND U.NRORG = :P_NRORG  
                                   AND L.NRLISTA = :P_NRLISTA
                                )
                           UNPIVOT 
                              (VRMES  FOR MES IN(VRMES01, VRMES02, VRMES03, VRMES04, VRMES05, VRMES06, VRMES07, VRMES08, VRMES09, VRMES10, VRMES11, VRMES12)) 
                        ) UNI, FILIAL F  
                     WHERE (INSTR('". substr($mes, 0, -1) ."', UNI.MES) > 0 OR '". substr($mes, 0, -1) ."' = 'T')
                       AND UNI.CDFILIAL = F.CDFILIAL
                       AND UNI.IDATIVO = 'S'
                     GROUP BY MES, UNI.CDFILIAL, F.NMFILIAL
                    HAVING SUM(VRMES) <> 100
                    ORDER BY UNI.CDFILIAL, SUBSTR(UNI.MES, 6, 2)";
        try {
            $stmt = $this->connection->prepare($query);
            $stmt->execute($paramSelect);
            $data = $stmt->fetchAll();
            return($data);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function checkRowsMonthGridGeneral($params){
        $query = "SELECT SUM (VRMES)VRMES, INITCAP(TRIM(TO_CHAR(TO_DATE(SUBSTR(GER.MES, 6, 2), 'MM'), 'MONTH', 'NLS_DATE_LANGUAGE = PORTUGUESE')))MES
                      FROM(
                            SELECT * 
                              FROM(
                                SELECT G.* 
                                  FROM ARRECADAADMGER G
                                 WHERE G.CDANO = :P_CDANO
                                   AND G.NRORG = :P_NRORG
                                )
                           UNPIVOT 
                              (VRMES  FOR MES IN(VRMES01, VRMES02, VRMES03, VRMES04, VRMES05, VRMES06, VRMES07, VRMES08, VRMES09, VRMES10, VRMES11, VRMES12)) 
                        ) GER
                     GROUP BY MES
                    HAVING SUM(VRMES) <> 100
                    ORDER BY  SUBSTR(GER.MES, 6, 2)";
        try {
            $stmt = $this->connection->prepare($query);
            $stmt->execute($params);
            $data = $stmt->fetchAll();
            return($data);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function checkRowsMonthGridUnity($paramSelect, $mes){
        $query = "SELECT SUM (VRMES)VRMES, INITCAP(TRIM(TO_CHAR(TO_DATE(SUBSTR(UNI.MES, 6, 2), 'MM'), 'MONTH', 'NLS_DATE_LANGUAGE = PORTUGUESE')))MES, UNI.CDFILIAL, F.NMFILIAL
                      FROM(
                            SELECT * 
                              FROM(
                                SELECT U.* 
                                  FROM ARRECADAADMUNI U, FILIAL F
                                 WHERE U.CDFILIAL = F.CDFILIAL
                                   AND U.CDANO = :P_CDANO
                                   AND U.NRORG = :P_NRORG  
                                   AND F.CDFILIAL = :P_CDFILIAL
                                   AND EXISTS(
                                                SELECT GER.CDFILIALADM  
                                                  FROM ARRECADAADMGER GER
                                                  WHERE 
                                                        GER.CDFILIALADM = U.CDFILIALADM
                                                    AND GER.IDATIVO = 'S'
                                            ) 
                                )
                           UNPIVOT 
                              (VRMES  FOR MES IN(VRMES01, VRMES02, VRMES03, VRMES04, VRMES05, VRMES06, VRMES07, VRMES08, VRMES09, VRMES10, VRMES11, VRMES12)) 
                        ) UNI, FILIAL F  
                     WHERE (INSTR( '". $mes . "' , UNI.MES) > 0 OR '" . $mes . "' = 'T')
                       AND UNI.CDFILIAL = F.CDFILIAL
                     GROUP BY MES, UNI.CDFILIAL, F.NMFILIAL
                    HAVING SUM(VRMES) <> 100
                    ORDER BY UNI.CDFILIAL, SUBSTR(MES, 6, 2)";
        try {
            $stmt = $this->connection->prepare($query);
            $stmt->execute($paramSelect);
            $data = $stmt->fetchAll();
            return($data);
        } catch (Exception $e){
            throw $e;
        }
    }
}