function NavigationLog(templateManager, ApplicationContext, ZhLogger) {

	var eventAggregator;
	templateManager.projectPromise.then(function() {
		eventAggregator = ApplicationContext.eventAggregator;
		var navigationLog = templateManager.project.navigationLog;
		if (navigationLog) {
			if (!Util.isObject(navigationLog)) {
				ZhLogger.error("navigationLog property should be an object");
			} else {
				makeBindings();
				var navigationLogEvents = navigationLog.events;
				if (navigationLogEvents) {
					if (!Util.isArray(navigationLogEvents)) {
						ZhLogger.error("navigationLog.events property should be an array of event names");
					} else {
						navigationLogEvents.forEach(function(eventName) {
							eventAggregator.subscribe(eventName, function(data) {
								ZhLogger.info("[NavigationLog] " + eventName + " event called with data: ", data);
							});
						});
					}
				}
			}
		}
	});

	var makeBindings = function makeBindings() {
		eventAggregator.subscribe("onContainerOpen", function(data) {
			ZhLogger.info("[NavigationLog] Accessed container : " + data.container.name, data.container);
		});

		eventAggregator.subscribe("afterOpenReport", function(data) {
			ZhLogger.info("[NavigationLog] Opened " + data.reportType + " report ", data);
		});
	};

	this.logEvent = function logEvent(eventName, owner) {
		var navigationLog = templateManager.project.navigationLog;
		if (navigationLog && navigationLog.logAll) {
			var msg = "";
			if (owner.name) {
				msg = "Caller info: " + owner.name;
				if (owner.label) {
					msg += ", label: " + owner.label;
				}
			} else {
				if (owner.container && owner.container.name) {
					msg = "Caller container: " + owner.container.name;
				}
			}
			ZhLogger.info("[NavigationLog] Event " + eventName + " fired! " + msg);
		}
	};
}